package net.ihe.gazelle.ordermanager.model;

import net.ihe.gazelle.hql.HQLQueryBuilder;
import net.ihe.gazelle.simulator.common.tf.model.Actor;
import net.ihe.gazelle.simulator.common.tf.model.Domain;

import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.MappedSuperclass;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import java.util.Date;
import java.util.List;

/**
 * Class description : <b>AbstractOrder</b>
 * 
 * This class is the base class for describing orders in multiple domains.
 * 
 * This class defines the following attributes
 * <ul>
 * <li><b>id</b> unique identifier in the database</li>
 * <li><b>orderControlCode</b></li>
 * <li><b>domain</b> indicates the domain in which the order is created</li>
 * <li><b>simulatedActor</b> indicates which actor holds the order</li>
 * <li><b>encounter</b> indicates the encounter to which the order is related</li>
 * <li><b>placerOrderNumber</b> identifies the order in the order placer side</li>
 * <li><b>fillerOrderNumber</b> identifies the order in the order filler side</li>
 * <li><b>quantityTiming</b> is the priority of the order</li>
 * <li><b>transactionDate</b></li>
 * <li><b>enteredBy</b></li>
 * <li><b>orderingProvider</b></li>
 * <li><b>callBackPhoneNumber</b></li>
 * <li><b>enteringOrganization</b></li>
 * <li><b>universalServiceId</b></li>
 * <li><b>technician</b></li>
 * <li><b>orderStatus</b></li>
 * <li><b>startDateTime</b></li>
 * <li><b>lastChanged</b> indicates when the order has been modified for the last time</li>
 * <li><b>creator</b></li>
 * <ul>
 * 
 *
 *
 * @author Anne-Gaëlle Bergé - INRIA Rennes/Bretagne Atlantique
 *
 * @version 1.0 - 2011, December 5th
 * 
 */

@MappedSuperclass
public abstract class AbstractOrder extends CommonColumns {

	public static final String STATUS_UNKNOWN = "Unknown";

	@Column(name = "order_control_code")
	private String orderControlCode;

	@ManyToOne
	@JoinColumn(name = "encounter_id")
	private Encounter encounter;

	/**
	 * ORC-2, OBR-2 In LAW, we use this attribute as the AWOS ID (generated by the Analyzer Mgr)
	 */
	@Column(name = "placer_order_number")
	private String placerOrderNumber;

	/**
	 * ORC-3, OBR-3
	 */
	@Column(name = "filler_order_number")
    private String fillerOrderNumber;

	/**
	 * ORC-4
	 */
	@Column(name = "placer_group_number")
    private String placerGroupNumber;

	/**
	 * ORC-7.6, OBR-27.6 TQ1-9
	 */
	@Column(name = "quantity_timing")
    private String quantityTiming;

	/**
	 * ORC-9
	 */
	@Column(name = "transaction_date")
	@Temporal(TemporalType.TIMESTAMP)
    private Date transactionDate;

	/**
	 * ORC-10
	 */
	@Column(name = "entered_by")
    private String enteredBy;

	/**
	 * ORC-12, OBR-16
	 */
	@Column(name = "ordering_provider")
    private String orderingProvider;

	/**
	 * ORC-14
	 */
	@Column(name = "call_back_phone_number")
    private String callBackPhoneNumber;

	/**
	 * ORC-17
	 */
	@Column(name = "entering_organization")
    private String enteringOrganization;

	/**
	 * OBR-4
	 */
	@Column(name = "universal_service_id")
    private String universalServiceId;

	/**
	 * OBR-25
	 */
	@Column(name = "order_result_status")
    private String orderResultStatus;

	/**
	 * OBR-31
	 */
	@Column(name = "reason_for_study")
    private String reasonForStudy;

	/**
	 * OBR-34
	 */
	@Column(name = "technician")
    private String technician;

	/**
	 * ORC-5
	 */
	@Column(name = "order_status")
    private String orderStatus;

	/**
	 * ORC-7.4 and OBR-27.4
	 */
	@Column(name = "start_date_time")
	@Temporal(TemporalType.TIMESTAMP)
    private Date startDateTime;

	/**
	 * ORC-21
	 */
	@Column(name = "ordering_facility_name")
    private String orderingFacilityName;

	/**
	 * OBR-12
	 */
	@Column(name = "danger_code")
    private String dangerCode;

	/**
	 * OBR-13
	 */
	@Column(name = "relevant_clinical_info")
    private String relevantClinicalInfo;

	/**
	 * Default constructor
	 */
	public AbstractOrder() {
		super();
	}
	
	public AbstractOrder(Actor simulatedActor, String username, Domain inDomain){
		super(simulatedActor, username, inDomain);
	}

	/**
	 * Saves the order and returns the merged object
	 * 
	 * @param clazz
	 * @param entityManager
	 * @return the order
	 */
	@SuppressWarnings("unchecked")
	protected <T> T save(Class<T> clazz, EntityManager entityManager) {
		this.setLastChanged(new Date());
		T order = (T) entityManager.merge(this);
		entityManager.flush();
		return order;
	}
	/**
	 * 
	 * @param inDomain
	 * @param simulatedActor
	 *            : this parameter is needed since in some cases, attributes optionality differs from an actor to the other
	 */
	public abstract void fillOrderRandomly(Domain inDomain, Actor simulatedActor);

	/**
	 *
	 * @return clazz
	 */
	public static <T> T getOrderByNumbersByActor(Class<T> clazz, String placerOrderNumber, String fillerOrderNumber,
			String placerGroupNumber, Actor simulatedActor, EntityManager entityManager, Boolean isWorkOrder) {
		HQLQueryBuilder<T> queryBuilder = new HQLQueryBuilder<T>(entityManager, clazz);
		if ((placerOrderNumber != null) && !placerOrderNumber.isEmpty()) {
			queryBuilder.addEq("placerOrderNumber", placerOrderNumber);
		}
		if ((fillerOrderNumber != null) && !fillerOrderNumber.isEmpty()) {
			queryBuilder.addEq("fillerOrderNumber", fillerOrderNumber);
		}
		if ((placerGroupNumber != null) && !placerGroupNumber.isEmpty()) {
			queryBuilder.addEq("placerGroupNumber", placerGroupNumber);
		}
		if (isWorkOrder != null) {
			queryBuilder.addEq("workOrder", isWorkOrder);
		}
		queryBuilder.addEq("simulatedActor", simulatedActor);
		List<T> orders = queryBuilder.getList();
		if (!orders.isEmpty()) {
			return orders.get(0);
		} else {
			return null;
		}
	}

	public Encounter getEncounter() {
		return encounter;
	}

	public void setEncounter(Encounter encounter) {
		this.encounter = encounter;
	}

	public String getPlacerOrderNumber() {
		return placerOrderNumber;
	}

	public void setPlacerOrderNumber(String placerOrderNumber) {
		this.placerOrderNumber = placerOrderNumber;
	}

	public String getFillerOrderNumber() {
		return fillerOrderNumber;
	}

	public void setFillerOrderNumber(String fillerOrderNumber) {
		this.fillerOrderNumber = fillerOrderNumber;
	}

	public String getQuantityTiming() {
		return quantityTiming;
	}

	public void setQuantityTiming(String quantityTiming) {
		this.quantityTiming = quantityTiming;
	}

	public Date getTransactionDate() {
        if (transactionDate != null) {
            return (Date) transactionDate.clone();
        } else {
            return null;
        }
	}

	public void setTransactionDate(Date transactionDate) {
        if (transactionDate != null) {
            this.transactionDate = (Date) transactionDate.clone();
        } else {
            this.transactionDate = null;
        }
	}

	public String getEnteredBy() {
		return enteredBy;
	}

	public void setEnteredBy(String enteredBy) {
		this.enteredBy = enteredBy;
	}

	public String getOrderingProvider() {
		return orderingProvider;
	}

	public void setOrderingProvider(String orderingProvider) {
		this.orderingProvider = orderingProvider;
	}

	public String getCallBackPhoneNumber() {
		return callBackPhoneNumber;
	}

	public void setCallBackPhoneNumber(String callBackPhoneNumber) {
		this.callBackPhoneNumber = callBackPhoneNumber;
	}

	public String getEnteringOrganization() {
		return enteringOrganization;
	}

	public void setEnteringOrganization(String enteringOrganization) {
		this.enteringOrganization = enteringOrganization;
	}

	public String getUniversalServiceId() {
		return universalServiceId;
	}

	public void setUniversalServiceId(String universalServiceId) {
		this.universalServiceId = universalServiceId;
	}

	public String getReasonForStudy() {
		return reasonForStudy;
	}

	public void setReasonForStudy(String reasonForStudy) {
		this.reasonForStudy = reasonForStudy;
	}

	public String getTechnician() {
		return technician;
	}

	public void setTechnician(String technician) {
		this.technician = technician;
	}

	/**
	 * @param orderControlCode
	 *            the orderControlCode to set
	 */
	public void setOrderControlCode(String orderControlCode) {
		this.orderControlCode = orderControlCode;
	}

	/**
	 * @return the orderControlCode
	 */
	public String getOrderControlCode() {
		return orderControlCode;
	}

	/**
	 * @param orderStatus
	 *            the orderStatus to set
	 */
	public void setOrderStatus(String orderStatus) {
		this.orderStatus = orderStatus;
	}

	/**
	 * @return the orderStatus
	 */
	public String getOrderStatus() {
		return orderStatus;
	}

	/**
	 * @param startDateTime
	 *            the startDateTime to set
	 */
	public void setStartDateTime(Date startDateTime) {
        if (startDateTime != null) {
            this.startDateTime = (Date) startDateTime.clone();
        } else {
            this.startDateTime = null;
        }
	}

	/**
	 * @return the startDateTime
	 */
	public Date getStartDateTime() {
        if (startDateTime != null) {
            return (Date) startDateTime.clone();
        } else {
            return null;
        }
	}

	public String getPlacerGroupNumber() {
		return placerGroupNumber;
	}

	public void setPlacerGroupNumber(String placerGroupNumber) {
		this.placerGroupNumber = placerGroupNumber;
	}

	public void setOrderResultStatus(String orderResultStatus) {
		this.orderResultStatus = orderResultStatus;
	}

	public String getOrderResultStatus() {
		return orderResultStatus;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = (prime * result) + ((fillerOrderNumber == null) ? 0 : fillerOrderNumber.hashCode());
		result = (prime * result) + ((placerGroupNumber == null) ? 0 : placerGroupNumber.hashCode());
		result = (prime * result) + ((placerOrderNumber == null) ? 0 : placerOrderNumber.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AbstractOrder other = (AbstractOrder) obj;
		if (fillerOrderNumber == null) {
			if (other.fillerOrderNumber != null) {
				return false;
			}
		} else if (!fillerOrderNumber.equals(other.fillerOrderNumber)) {
			return false;
		}
		if (placerGroupNumber == null) {
			if (other.placerGroupNumber != null) {
				return false;
			}
		} else if (!placerGroupNumber.equals(other.placerGroupNumber)) {
			return false;
		}
		if (placerOrderNumber == null) {
			if (other.placerOrderNumber != null) {
				return false;
			}
		} else if (!placerOrderNumber.equals(other.placerOrderNumber)) {
			return false;
		}
		return true;
	}

	public String getOrderingFacilityName() {
		return orderingFacilityName;
	}

	public void setOrderingFacilityName(String orderingFacilityName) {
		this.orderingFacilityName = orderingFacilityName;
	}

	public String getDangerCode() {
		return dangerCode;
	}

	public String getRelevantClinicalInfo() {
		return relevantClinicalInfo;
	}

	public void setDangerCode(String dangerCode) {
		this.dangerCode = dangerCode;
	}

	public void setRelevantClinicalInfo(String relevantClinicalInfo) {
		this.relevantClinicalInfo = relevantClinicalInfo;
	}

}
